---------------------------------------------------------------
--                                                           
--  PENCIL AND PAPER INTERPRETER
--  By: Martin Carlisle and Al White     
--                                                           
--  Read Dialog 
--  Description : variables and routines for reading from keyboard
--                       
--  By: Martin Carlisle
--                                         
-- PENCIL AND PAPER INTERPRETER is free software; you can redistribute 
-- it and/or modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--  
-- PENCIL AND PAPER INTERPRETER is distributed in the hope that it will 
-- be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
with Mcc.Gui.Container.Window;
with Mcc.Gui.Widget.Text_Entry;
with State;
with Pencil_And_Paper_Computer;
with Read_Dialog_Window;
with Mcc.Gui.Keys;
with Controls;
package body Read_Dialog is

   procedure Close_Window (Obj : in out Mcc.Gui.Container.Window.Window'Class) is
   begin
      Mcc.Gui.Bell;
   end Close_Window;
   
   --------
   -- Ok --
   --------
   procedure Ok is
      Good_String : Boolean;
   begin
      Read_Dialog_Window.Read_Window(Good_String);
      if not Good_String then
         Mcc.Gui.Bell;
         Mcc.Gui.Widget.Text_Entry.Highlight(
            Read_Dialog_Window.Value_Text);
      else
         Mcc.Gui.Container.Window.Destroy(
            Read_Dialog_Window.Read_Dialog_Window);
         Post_Process.All(Value);
         Controls.Read_Complete;
      end if;
   end Ok;   

   procedure Ok (Obj : in out Mcc.Gui.Widget.Button.Button'Class) is
   begin
      Ok;
   end Ok;

   procedure Key_Callback (
      Obj   : in out Mcc.Gui.Sized_Object'Class;
      Event : in     Mcc.Gui.Key_Event) is
      use Mcc.Gui;
   begin
      if Event.Action=Release and Event.Key=Mcc.Gui.Keys.Enter then
         Ok;
      elsif Event.Action=Release and Mcc.Gui.Widget.Text_Entry.Get_Text_Length(
         Read_Dialog_Window.Value_Text) > 3 then
         Mcc.Gui.Bell;
         declare
            Current : String := Mcc.Gui.Widget.Text_Entry.Get_Text(
               Read_Dialog_Window.Value_Text);
         begin
            Mcc.Gui.Widget.Text_Entry.Set_Text(
               Obj => Read_Dialog_Window.Value_Text,
               Text => Current(Current'First..Current'First+2));
         end;
      end if;
   end Key_Callback;

   procedure Initialize is
      Window_X : Integer := 250;
      Window_Y : Integer := 250;
   begin
      Mcc.Gui.Container.Window.Move(
         Obj => Read_Dialog_Window.Read_Dialog_Window,
         X   => Window_X,
         Y   => Window_Y);
      Mcc.Gui.Widget.Text_Entry.Highlight(
         Read_Dialog_Window.Value_Text);
      Mcc.Gui.Set_Key_Listener(
         Obj      => Read_Dialog_Window.Value_Text'access,
         Listener => Key_Callback'access);
      Mcc.Gui.Container.Window.Set_Close_Handler(
         Obj     => Read_Dialog_Window.Read_Dialog_Window'access,
         Handler => Close_Window'access);
      
   end Initialize;
end Read_Dialog;

